// this modules fixes the drain error on win32
// fix for https://github.com/joyent/node/issues/3584
// code from https://github.com/joyent/node/issues/3871 by https://github.com/mistaecko

var is_windows = process.platform == 'win32',
    exit = process.exit;

process.exit = function(code) {
  if (!is_windows)
    return exit(code);

  var draining = 0;
  var done = function() {
    if (!draining--) exit(code);
  };

  [process.stdout, process.stderr].forEach(function(stream) {
    if (stream.bufferSize) {
      draining++;
      stream.write('', 'utf-8', done);
      stream.write = function() {}; // prevent further writing
    }
  })

  if (!draining)
    exit(code);

  process.on('exit', function() {
    exit(code);
  });
}